=begin
  (filter/)price.rb
    nDiary Filter  ƌvIl̍쐬
    z.pricet@C𐶐܂B
    plugin/price.rbƂ킹ėpAȂʂ̏WvvOƗpB
    format:
      .priset@C1s1ATAB؂
      date, anchor, title, type, code, price
      8t, LAJ[, i, i^(book,cd), ^(ISBN), i
      ȏŏ\Ǝv̂łB
=end

class PastDiary
  attr_reader   :cntTopic, :cntParagraph
  #OiAJ[܂ŏE悤ɁBƂʂdefpӂĂH
end

class Filter
  BOOKSTORE = Regexp::compile(/[\(i]ISBN[:|F]?\s?(\d-[\d-]{9}[-]?[\w]?)[\)j]/)
  #BOOKSTOREbookstorȅʃRp`̐K\̂͂Bd`waro邯ǏȂ
  AMAZON    = Regexp::compile(/[\(i]amz:(\d-[\d-]{9}-\w)[\)j]/)
  PRICETAG  = Regexp::compile(/<!--Tag:price:(.*?)-->/)
  #ex) <!--Tag:price:title=title:type=CD:\2000-->
  def price(str, type)
    return if @diary.type != PastDiary
    #BfilterނDiary(LastDiary,PastDiary)ɍƂłĂ邾낤H@IvVall̎ɕscB
    unless @flag_initial #initialize
      @flag_initial = true
      @expire = 12
      @flag_net = @diary.config['nonet']
      @filename = @diary.logDirectory + @diary.targetMonth + '.price'
      File.delete(@filename) if File.exist?(@filename)
      @flag_tag = true
      @flag_bookstore_x = true
      @flag_amazon = false
      @flag_bookstore = false
      if @flag_bookstore_x #e̊œK
        require '../../ruby/simpleuri'
        require '../../ruby/webagent'
        require '../../ruby/cache'
        require '../../ruby/amazon'
        require '../../ruby/bk1'
        require '../../ruby/esbooks'
        require '../../ruby/asahiya'
        require '../../ruby/jbook'
        require '../../ruby/kinokuniya'
        require '../../ruby/skysoft'
        @cache_amz = "../../bookcache/amz"
        @cache_bk1 = "../../bookcache/bk1"
        @cache_esb = "../../bookcache/esb"
        @cache_ash = "../../bookcache/ash"
        @cache_jbk = "../../bookcache/jbk"
        @cache_kin = "../../bookcache/kin"
        @cache_sky = "../../bookcache/sky"
      end
    end
    
    case type
    when :P, :DL, :UL
      list = []
      #-----tag search-----
      str.scan(PRICETAG){
        str = $1
        title, type, code, price = '', '', '', ''
        str.split(/:/).each{ |word|
          tag, val = word.split(/=/)
          case tag
          when 'title'
            title = val
          when 'type'
            type = val
          when 'code'
            code = val
          when 'price'
            price = val
          end
          price = tag if tag =~ /^\\|/
          price = price.gsub(/[\\||,|~|iŔj]/,'').strip
        }
        list << [title, type, code, price]
      } if @flag_tag
      #-----ISBN search (for bookstore.rb)-----
      str.scan(BOOKSTORE){
        isbn = $1
        #chache -> price ?
        title, type, price = '', 'book', ''
        list << [title, type, isbn, price]
      } if @flag_bookstore
      #-----ISBN search (for bookstore_x.rb)-----
      str.scan(BOOKSTORE){
        isbn1 = $1
        isbn2 = isbn1.delete('-')
        checkbook = CacheBib.new()
        newisbn = checkbook.isbn_check(isbn1)
        isbn1 = newisbn
        info = {}
        book = CacheBib_amazon.new()
        book.expire = @expire
        book.cache_dir = @cache_amz
        ainfo = book.get_data(isbn1, @flag_net)
        book = CacheBib_bk1.new()
        book.expire = @expire
        book.cache_dir = @cache_bk1
        binfo = book.get_data(isbn1, @flag_net)
        book = CacheBib_esbooks.new()
        book.expire = @expire
        book.cache_dir = @cache_esb
        einfo = book.get_data(isbn1, @flag_net)
        book = CacheBib_asahiya.new()
        book.expire = @expire
        book.cache_dir = @cache_ash
        sinfo = book.get_data(isbn1, @flag_net)
        book = CacheBib_jbook.new()
        book.expire = @expire
        book.cache_dir = @cache_jbk
        jinfo = book.get_data(isbn1, @flag_net)
        book = CacheBib_kinokuniya.new()
        book.expire = @expire
        book.cache_dir = @cache_kin
        kinfo = book.get_data(isbn1, @flag_net)
        book = CacheBib_skysoft.new()
        book.expire = @expire
        book.cache_dir = @cache_sky
        yinfo = book.get_data(isbn1, @flag_net)
        isbn = isbn1
        info = checkbook.merge_info( [ainfo, binfo, einfo, sinfo, jinfo, kinfo, yinfo] )
        title, type, price = info['title'], 'book', info['price']
        price = price.gsub(/[\\||,|~|iŔj]/,'').strip
        list << [title, type, isbn, price]
      } if @flag_bookstore_x
      #-----ASIN search (for amazon.rb)-----
      #eXg
      str.scan(AMAZON){
        isbn = $1
        amz = Amazon::new
        amz.cache_dir = @diary.logDirectory + 'amzcache'
        amz.isbn = isbn
        if @diary.respond_to?('config') then
          amz.expire = @diary.config['AMAZON_EXPIRE'] || 7
          amz.proxy = @diary.config['PROXY']
        end
        title, type, price = amz.title, 'book', amz.price
        price = price.gsub(/[\\||,|~|iŔj]/,'').strip
        list << [title, type, isbn, price]
      } if @flag_amazon
      #-----list-----
      #HcntParagraphȁH
      unless list.empty?
        anchor = ''
        if @diary.paragraphAnchor then
          if @diary.anchorEachTopic then
            anchor = "_t#{@diary.cntTopic}_#{@diary.cntParagraph+1}"
          else
            anchor = "_#{@diary.cntParagraph+1}"
          end
        end
        anchor = "#{@diary.date2monthlyfilelink(@diary.date, true)}#{anchor}"
        open(@filename, 'a'){ |fp|
          list.each{ |line|
#            line.unshift(anchor)
#            line.unshift(@diary.date)
#            fp.puts line.join("\t")
            fp.puts [@diary.date, anchor, *line].join("\t")
            #o̓tH[}bgdate,anchor,title,type,code,priceTAB؂
          }
        }
      end
    end
  end
end
